Index: src/sas/qtgui/Perspectives/Invariant/InvariantPerspective.py
===================================================================
--- src/sas/qtgui/Perspectives/Invariant/InvariantPerspective.py	(revision 4992ff2626be19df7de9e5dfc0078b96bf47a75e)
+++ src/sas/qtgui/Perspectives/Invariant/InvariantPerspective.py	(revision f1f3e6a66c47bce134b59fe9f166fe14eac3a61d)
@@ -2,8 +2,11 @@
 import sys
 import os
+import logging
+import copy
+import webbrowser
+
 from PyQt5 import QtCore
-from PyQt5 import QtGui
-from PyQt5 import QtWidgets
-from PyQt5 import QtWebKitWidgets
+from PyQt5 import QtGui, QtWidgets
+from PyQt5 import QtWebKit
 
 from twisted.internet import threads
@@ -14,4 +17,6 @@
 from sas.qtgui.Plotting.PlotterData import Data1D
 import sas.qtgui.Utilities.GuiUtils as GuiUtils
+
+# import sas.qtgui.Plotting.PlotHelper as PlotHelper
 
 # local
@@ -26,21 +31,19 @@
 # the ratio of maximum q value/(qmax of data) to plot the theory data
 Q_MAXIMUM_PLOT = 3
-
-
-class MyModel(object):
-    def __init__(self):
-        self._model = QtGui.QStandardItemModel(self)
-
-    def addItem(self, item):
-        item = QtGui.QStandardItem(str(item))
-        self._model.appendRow(item)
+# Default number of points of interpolation: high and low range
+NPOINTS_Q_INTERP = 10
+# Default power law for interpolation
+DEFAULT_POWER_LOW = 4
+
+# Background of line edits if settings OK or wrong
+BG_WHITE = "background-color: rgb(255, 255, 255);"
+BG_RED = "background-color: rgb(244, 170, 164);"
 
 class InvariantWindow(QtWidgets.QDialog, Ui_tabbedInvariantUI):
     # The controller which is responsible for managing signal slots connections
     # for the gui and providing an interface to the data model.
-    name = "Invariant" # For displaying in the combo box
-    #def __init__(self, manager=None, parent=None):
+    name = "Invariant"  # For displaying in the combo box in DataExplorer
+
     def __init__(self, parent=None):
-        #super(InvariantWindow, self).__init__(parent)
         super(InvariantWindow, self).__init__()
         self.setupUi(self)
@@ -52,27 +55,33 @@
         self._scale = 1.0
         self._contrast = 1.0
-        self._porod = 1.0
-        self._npoints_low = 10
-        self._npoints_high = 10
-        self._power_low = 4
+        self._porod = None
+
+        self.parent = parent
 
         self._manager = parent
-        #self._manager = manager
         self._reactor = reactor
         self._model_item = QtGui.QStandardItem()
 
-        self._helpView = QtWebKitWidgets.QWebView()
+        #self._helpView = QtWebKit.QWebView()
         self.detailsDialog = DetailsDialog(self)
+        self.detailsDialog.cmdOK.clicked.connect(self.enabling)
 
         self._low_extrapolate = False
-        self._low_guinier  = True
-        self._low_fit  = True
+        self._low_guinier = True
+        self._low_fit = False
+        self._low_power_value = False
+        self._low_points = NPOINTS_Q_INTERP
+        self._low_power_value = DEFAULT_POWER_LOW
+
         self._high_extrapolate = False
-        self._high_power_value  = False
+        self._high_power_value = False
+        self._high_fit = False
+        self._high_points = NPOINTS_Q_INTERP
+        self._high_power_value = DEFAULT_POWER_LOW
 
         # no reason to have this widget resizable
         self.setFixedSize(self.minimumSizeHint())
 
-        self.communicate = GuiUtils.Communicate()
+        self.communicate = self._manager.communicator()
 
         self._data = None
@@ -81,17 +90,25 @@
         self._allow_close = False
 
-        # Mask file selector
-        ###################################################
-        #self._path = "cyl_400_20.txt"
-        #from sas.sascalc.dataloader.loader import  Loader
-        #loader = Loader()
-        #try:
-        #    self._data = loader.load(self._path)
-        #except:
-        #    raise
-        ###################################################
-
-        self.lineEdit_8.setText(str(Q_MINIMUM))
-        self.lineEdit_9.setText(str(Q_MAXIMUM))
+        # Modify font in order to display Angstrom symbol correctly
+        new_font = 'font-family: -apple-system, "Helvetica Neue", "Ubuntu";'
+        self.lblTotalQUnits.setStyleSheet(new_font)
+        self.lblSpecificSurfaceUnits.setStyleSheet(new_font)
+        self.lblInvariantTotalQUnits.setStyleSheet(new_font)
+        self.lblContrastUnits.setStyleSheet(new_font)
+        self.lblPorodCstUnits.setStyleSheet(new_font)
+        self.lblExtrapolQUnits.setStyleSheet(new_font)
+
+        # To remove blue square around line edits
+        self.txtBackgd.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtContrast.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtScale.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtPorodCst.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtNptsHighQ.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtNptsLowQ.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtPowerLowQ.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+        self.txtPowerHighQ.setAttribute(QtCore.Qt.WA_MacShowFocusRect, False)
+
+        self.txtExtrapolQMin.setText(str(Q_MINIMUM))
+        self.txtExtrapolQMax.setText(str(Q_MAXIMUM))
 
         # Let's choose the Standard Item Model.
@@ -108,13 +125,27 @@
         self.setupMapper()
 
-        new_font = 'font-family: -apple-system, "Helvetica Neue", "Ubuntu";'
-        self.label_2.setStyleSheet(new_font)
-        self.label_24.setStyleSheet(new_font)
-        self.label_27.setStyleSheet(new_font)
+        # validator: double
+        self.txtBackgd.setValidator(QtGui.QDoubleValidator())
+        self.txtContrast.setValidator(QtGui.QDoubleValidator())
+        self.txtScale.setValidator(QtGui.QDoubleValidator())
+        self.txtPorodCst.setValidator(QtGui.QDoubleValidator())
+
+        # validator: integer number
+        valid_regex_int = QtCore.QRegExp('^[+]?(\d+[.][0]*)$')
+        self.txtNptsLowQ.setValidator(QtGui.QRegExpValidator(valid_regex_int,
+                                                             self.txtNptsLowQ))
+        self.txtNptsHighQ.setValidator(QtGui.QRegExpValidator(valid_regex_int,
+                                                             self.txtNptsHighQ))
+        self.txtPowerLowQ.setValidator(QtGui.QRegExpValidator(valid_regex_int,
+                                                             self.txtPowerLowQ))
+        self.txtPowerHighQ.setValidator(QtGui.QRegExpValidator(valid_regex_int,
+                                                             self.txtPowerHighQ))
+
+    def enabling(self):
+        """ """
+        self.cmdStatus.setEnabled(True)
 
     def setClosable(self, value=True):
-        """
-        Allow outsiders close this widget
-        """
+        """ Allow outsiders close this widget """
         assert isinstance(value, bool)
 
@@ -134,86 +165,94 @@
             self.setWindowState(QtCore.Qt.WindowMinimized)
 
-    def communicator(self):
-        """ Getter for the communicator """
-        return self.communicate
-
     def updateFromModel(self):
-        """
-        update the globals based on the data in the model
-        """
+        """ Update the globals based on the data in the model """
         self._background = float(self.model.item(WIDGETS.W_BACKGROUND).text())
-        self._contrast   = float(self.model.item(WIDGETS.W_CONTRAST).text())
-        self._scale      = float(self.model.item(WIDGETS.W_SCALE).text())
-
-        # High extrapolate
-        self._low_extrapolate = ( str(self.model.item(WIDGETS.W_ENABLE_LOWQ).text()) == 'true')
+        self._contrast = float(self.model.item(WIDGETS.W_CONTRAST).text())
+        self._scale = float(self.model.item(WIDGETS.W_SCALE).text())
+        if self.model.item(WIDGETS.W_POROD_CST).text() != 'None' \
+                and self.model.item(WIDGETS.W_POROD_CST).text() != '':
+            self._porod = float(self.model.item(WIDGETS.W_POROD_CST).text())
+
+        # Low extrapolating
+        self._low_extrapolate = str(self.model.item(WIDGETS.W_ENABLE_LOWQ).text()) == 'true'
         self._low_points = float(self.model.item(WIDGETS.W_NPTS_LOWQ).text())
-        self._low_guinier  = ( str(self.model.item(WIDGETS.W_LOWQ_GUINIER).text()) == 'true')
-        self._low_fit  = ( str(self.model.item(WIDGETS.W_LOWQ_FIT).text()) == 'true')
-        self._low_power_value  = float(self.model.item(WIDGETS.W_LOWQ_POWER_VALUE).text())
+        self._low_guinier = str(self.model.item(WIDGETS.W_LOWQ_GUINIER).text()) == 'true'
+        self._low_fit = str(self.model.item(WIDGETS.W_LOWQ_FIT).text()) == 'true'
+        self._low_power_value = float(self.model.item(WIDGETS.W_LOWQ_POWER_VALUE).text())
 
         # High extrapolating
-        self._high_extrapolate = ( str(self.model.item(WIDGETS.W_ENABLE_HIGHQ).text()) == 'true')
-        self._high_points  = float(self.model.item(WIDGETS.W_NPTS_HIGHQ).text())
-        self._high_fit  = ( str(self.model.item(WIDGETS.W_HIGHQ_FIT).text()) == 'true')
-        self._high_power_value  = float(self.model.item(WIDGETS.W_HIGHQ_POWER_VALUE).text())
+        self._high_extrapolate = str(self.model.item(WIDGETS.W_ENABLE_HIGHQ).text()) == 'true'
+        self._high_points = float(self.model.item(WIDGETS.W_NPTS_HIGHQ).text())
+        self._high_fit = str(self.model.item(WIDGETS.W_HIGHQ_FIT).text()) == 'true'
+        self._high_power_value = float(self.model.item(WIDGETS.W_HIGHQ_POWER_VALUE).text())
 
     def calculateInvariant(self):
-        """
-        Use twisted to thread the calculations away.
-        """
+        """ Use twisted to thread the calculations away """
         # Find out if extrapolation needs to be used.
         extrapolation = None
-        if self._low_extrapolate  and not self._high_extrapolate:
+        if self._low_extrapolate and not self._high_extrapolate:
             extrapolation = "low"
-        elif not self._low_extrapolate  and self._high_extrapolate:
+        elif not self._low_extrapolate and self._high_extrapolate:
             extrapolation = "high"
         elif self._low_extrapolate and self._high_extrapolate:
             extrapolation = "both"
-        try:
-            # modify the Calculate button to indicate background process
-            self.pushButton.setText("Calculating...")
-            self.pushButton.setEnabled(False)
-            self.style = self.pushButton.styleSheet()
-            self.pushButton.setStyleSheet("background-color: rgb(255, 255, 0); color: rgb(0, 0, 0)")
-            # Send the calculations to separate thread.
-            d = threads.deferToThread(self.calculateThread, extrapolation)
-            # Add deferred callback for call return
-            d.addCallback(self.plotResult)
-            d.addErrback(self.plotFailed)
-        except Exception as ex:
-            # Set the button back to available
-            self.pushButton.setEnabled(True)
-            self.pushButton.setText("Calculate")
-            self.pushButton.setStyleSheet(self.style)
-
-    def plotFailed(self, reason):
-        """
-        """
-        print("plotFailed FAILED: ", reason)
+
+        # modify the Calculate button to indicate background process
+        self.cmdCalculate.setText("Calculating...")
+        self.cmdCalculate.setEnabled(False)
+
+        # Send the calculations to separate thread.
+        d = threads.deferToThread(self.calculateThread, extrapolation)
+
+        # Add deferred callback for call return
+        d.addCallback(self.deferredPlot)
+        d.addErrback(self.calculationFailed)
+
+    def calculationFailed(self, reason):
+        print("calculation failed: ", reason)
         pass
 
+    def deferredPlot(self, model):
+        """
+        Run the GUI/model update in the main thread
+        """
+        reactor.callFromThread(lambda: self.plotResult(model))
+
     def plotResult(self, model):
-        """
-        """
+        """ Plot result of calculation """
+        # Set the button back to available
+        self.cmdCalculate.setEnabled(True)
+        self.cmdCalculate.setText("Calculate")
+        self.cmdStatus.setEnabled(True)
+
         self.model = model
         self.mapper.toFirst()
-
-        # Set the button back to available
-        self.pushButton.setEnabled(True)
-        self.pushButton.setText("Calculate")
-        self.pushButton.setStyleSheet(self.style)
+        self._data = GuiUtils.dataFromItem(self._model_item)
 
         # Send the modified model item to DE for keeping in the model
-        self.communicate.updateModelFromPerspectiveSignal.emit(self._model_item)
-
+        # Currently -unused
+        #self.communicate.updateModelFromPerspectiveSignal.emit(self._model_item)
+
+        plot_data = GuiUtils.plotsFromCheckedItems(self._manager.filesWidget.model)
+
+        self._manager.filesWidget.plotData(plot_data)
+
+        # Update the details dialog in case it is open
+        self.updateDetailsWidget(model)
+
+    def updateDetailsWidget(self, model):
+        """
+        On demand update of the details widget
+        """
+        if self.detailsDialog.isVisible():
+            self.onStatus()
 
     def calculateThread(self, extrapolation):
         """
         Perform Invariant calculations.
-
         TODO: Create a dictionary of results to be sent to DE on completion.
         """
         self.updateFromModel()
+        msg = ''
 
         qstar_low = 0.0
@@ -222,12 +261,14 @@
         qstar_high_err = 0.0
         qstar_total = 0.0
-        qstar_total_low_err = 0.0
+        qstar_total_error = 0.0
+
+        temp_data = copy.deepcopy(self._data)
 
         # Prepare the invariant object
-        inv = invariant.InvariantCalculator(data=self._data,
-                                            background = self._background,
-                                            scale = self._scale)
-
+        inv = invariant.InvariantCalculator(data=temp_data,
+                                            background=self._background,
+                                            scale=self._scale)
         if self._low_extrapolate:
+
             function_low = "power_law"
             if self._low_guinier:
@@ -235,6 +276,7 @@
             if self._low_fit:
                 self._low_power_value = None
+
             inv.set_extrapolation(range="low",
-                                  npts=self._low_points,
+                                  npts=int(self._low_points),
                                   function=function_low,
                                   power=self._low_power_value)
@@ -243,15 +285,14 @@
             function_low = "power_law"
             inv.set_extrapolation(range="high",
-                                  npts=self._high_points,
+                                  npts=int(self._high_points),
                                   function=function_low,
-                                  power=self._low_power_value)
-
-        #Compute invariant
-        # TODO: proper exception handling and logic -
-        # display info, update lineedits, don't run extrapolations etc.
+                                  power=self._high_power_value)
+        # Compute invariant
         calculation_failed = False
+
         try:
-            qstar_total, qstar_total_error         = inv.get_qstar_with_error()
+            qstar_total, qstar_total_error = inv.get_qstar_with_error()
         except Exception as ex:
+            msg += str(ex)
             calculation_failed = True
             # Display relevant information
@@ -260,9 +301,12 @@
             item = QtGui.QStandardItem("ERROR")
             self.model.setItem(WIDGETS.W_INVARIANT_ERR, item)
+
         try:
             volume_fraction, volume_fraction_error = \
                 inv.get_volume_fraction_with_error(self._contrast)
+
         except Exception as ex:
             calculation_failed = True
+            msg += str(ex)
             # Display relevant information
             item = QtGui.QStandardItem("ERROR")
@@ -270,134 +314,208 @@
             item = QtGui.QStandardItem("ERROR")
             self.model.setItem(WIDGETS.W_VOLUME_FRACTION_ERR, item)
-        try:
-            surface, surface_error = \
-                inv.get_surface_with_error(self._contrast, self._porod)
-        except Exception as ex:
-            calculation_failed = True
-            # Display relevant information
-            item = QtGui.QStandardItem("ERROR")
-            self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE, item)
-            item = QtGui.QStandardItem("ERROR")
-            self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE_ERR, item)
-
-        if(calculation_failed):
-            # TODO: NOTIFY THE GUI MANAGER!!
+
+        if self._porod:
+            try:
+                surface, surface_error = \
+                    inv.get_surface_with_error(self._contrast, self._porod)
+            except Exception as ex:
+                calculation_failed = True
+                msg += str(ex)
+                # Display relevant information
+                item = QtGui.QStandardItem("ERROR")
+                self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE, item)
+                item = QtGui.QStandardItem("ERROR")
+                self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE_ERR, item)
+        else:
+            surface = None
+
+        if (calculation_failed):
             self.mapper.toFirst()
+            logging.warning('Calculation failed: {}'.format(msg))
             return self.model
-
-        if self._low_extrapolate:
-            # for presentation in InvariantDetails
-            qstar_low, qstar_low_err = inv.get_qstar_low()
-            extrapolated_data = inv.get_extra_data_low(self._low_points)
-            power_low = inv.get_extrapolation_power(range='low')
-
-            #inv.data = extrapolated_data
-            #qstar_total, qstar_total_error = inv.get_qstar_with_error()
-
-            # Plot the chart
-            title = "Low-Q extrapolation"
-
-            # Convert the data into plottable
-            extrapolated_data = self._manager.createGuiData(extrapolated_data)
-            extrapolated_data.name = title
-            extrapolated_data.title = title
-
-            # Add the plot to the model item
-            # This needs to run in the main thread
-            reactor.callFromThread(GuiUtils.updateModelItemWithPlot,
-                    self._model_item, extrapolated_data, title)
-
-        if self._high_extrapolate:
-            # for presentation in InvariantDetails
-            qmax_plot = Q_MAXIMUM_PLOT * max(self._data.x)
-            if qmax_plot > Q_MAXIMUM:
-                qmax_plot = Q_MAXIMUM
-            qstar_high, qstar_high_err = inv.get_qstar_high()
-            power_high = inv.get_extrapolation_power(range='high')
-            high_out_data = inv.get_extra_data_high(q_end=qmax_plot, npts=500)
-
-            # Plot the chart
-            title = "High-Q extrapolation"
-
-            # Convert the data into plottable
-            high_out_data = self._manager.createGuiData(high_out_data)
-            high_out_data.name = title
-            high_out_data.title = title
-
-            # Add the plot to the model item
-            # This needs to run in the main thread
-            reactor.callFromThread(GuiUtils.updateModelItemWithPlot,
-                    self._model_item, high_out_data, title)
-
-        item = QtGui.QStandardItem(str(float('%.5g'% volume_fraction)))
-        self.model.setItem(WIDGETS.W_VOLUME_FRACTION, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% volume_fraction_error)))
-        self.model.setItem(WIDGETS.W_VOLUME_FRACTION_ERR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% surface)))
-        self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% surface_error)))
-        self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE_ERR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_total)))
-        self.model.setItem(WIDGETS.W_INVARIANT, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_total_error)))
-        self.model.setItem(WIDGETS.W_INVARIANT_ERR, item)
-
-        #item = QtGui.QStandardItem(str(float('%.5g'% qstar_total)))
-        #self.model.setItem(WIDGETS.D_TOTAL_QSTAR, item)
-        #item = QtGui.QStandardItem(str(float('%.5g'% qstar_total_err)))
-        #self.model.setItem(WIDGETS.D_TOTAL_QSTAR_ERR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_low)))
-        self.model.setItem(WIDGETS.D_LOW_QSTAR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_low_err)))
-        self.model.setItem(WIDGETS.D_LOW_QSTAR_ERR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_high)))
-        self.model.setItem(WIDGETS.D_HIGH_QSTAR, item)
-        item = QtGui.QStandardItem(str(float('%.5g'% qstar_high_err)))
-        self.model.setItem(WIDGETS.D_HIGH_QSTAR_ERR, item)
-
-        self.mapper.toFirst()
-
-        return self.model
-                
+        else:
+
+            if self._low_extrapolate:
+                # for presentation in InvariantDetails
+                qstar_low, qstar_low_err = inv.get_qstar_low()
+                extrapolated_data = inv.get_extra_data_low(self._low_points)
+                power_low = inv.get_extrapolation_power(range='low')
+
+                # Plot the chart
+                title = "Low-Q extrapolation"
+
+                # Convert the data into plottable
+                extrapolated_data = self._manager.createGuiData(extrapolated_data)
+
+                extrapolated_data.name = title
+                extrapolated_data.title = title
+
+                # copy labels and units of axes for plotting
+                extrapolated_data._xaxis = temp_data._xaxis
+                extrapolated_data._xunit = temp_data._xunit
+                extrapolated_data._yaxis = temp_data._yaxis
+                extrapolated_data._yunit = temp_data._yunit
+
+                # Add the plot to the model item
+                # This needs to run in the main thread
+                reactor.callFromThread(GuiUtils.updateModelItemWithPlot,
+                                       self._model_item,
+                                       extrapolated_data,
+                                       title)
+
+            if self._high_extrapolate:
+                # for presentation in InvariantDetails
+                qmax_plot = Q_MAXIMUM_PLOT * max(temp_data.x) # self._data.x)
+
+                if qmax_plot > Q_MAXIMUM:
+                    qmax_plot = Q_MAXIMUM
+                qstar_high, qstar_high_err = inv.get_qstar_high()
+                power_high = inv.get_extrapolation_power(range='high')
+                high_out_data = inv.get_extra_data_high(q_end=qmax_plot, npts=500)
+
+                # Plot the chart
+                title = "High-Q extrapolation"
+
+                # Convert the data into plottable
+                high_out_data = self._manager.createGuiData(high_out_data)
+                high_out_data.name = title
+                high_out_data.title = title
+
+                # copy labels and units of axes for plotting
+                high_out_data._xaxis = temp_data._xaxis
+                high_out_data._xunit = temp_data._xunit
+                high_out_data._yaxis = temp_data._yaxis
+                high_out_data._yunit = temp_data._yunit
+
+                # Add the plot to the model item
+                # This needs to run in the main thread
+                reactor.callFromThread(GuiUtils.updateModelItemWithPlot,
+                                       self._model_item, high_out_data, title)
+
+            item = QtGui.QStandardItem(str(float('%.3g'% volume_fraction)))
+            self.model.setItem(WIDGETS.W_VOLUME_FRACTION, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% volume_fraction_error)))
+            self.model.setItem(WIDGETS.W_VOLUME_FRACTION_ERR, item)
+            if surface:
+                item = QtGui.QStandardItem(str(float('%.3g'% surface)))
+                self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE, item)
+                item = QtGui.QStandardItem(str(float('%.3g'% surface_error)))
+                self.model.setItem(WIDGETS.W_SPECIFIC_SURFACE_ERR, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_total)))
+            self.model.setItem(WIDGETS.W_INVARIANT, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_total_error)))
+            self.model.setItem(WIDGETS.W_INVARIANT_ERR, item)
+
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_low)))
+            self.model.setItem(WIDGETS.D_LOW_QSTAR, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_low_err)))
+            self.model.setItem(WIDGETS.D_LOW_QSTAR_ERR, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_high)))
+            self.model.setItem(WIDGETS.D_HIGH_QSTAR, item)
+            item = QtGui.QStandardItem(str(float('%.3g'% qstar_high_err)))
+            self.model.setItem(WIDGETS.D_HIGH_QSTAR_ERR, item)
+
+            self.mapper.toFirst()
+
+            return self.model
+
     def title(self):
-        """
-        Perspective name
-        """
+        """ Perspective name """
         return "Invariant panel"
 
-    def status(self):
-        """
+    def onStatus(self):
+        """
+        Display Invariant Details panel when clicking on Status button
         """
         self.detailsDialog.setModel(self.model)
         self.detailsDialog.showDialog()
-
-    def help(self):
-        """
-        """
-        _TreeLocation = GuiUtils.HELP_DIRECTORY_LOCATION + \
+        self.cmdStatus.setEnabled(False)
+
+    def onHelp(self):
+        """ Display help when clicking on Help button """
+        treeLocation = GuiUtils.HELP_DIRECTORY_LOCATION + \
             "/user/sasgui/perspectives/invariant/invariant_help.html"
-        self._helpView.load(QtCore.QUrl(_TreeLocation))
-        self._helpView.show()
+        webbrowser.open('file://' + treeLocation)
 
     def setupSlots(self):
-        self.pushButton.clicked.connect(self.calculateInvariant)
-        self.pushButton_2.clicked.connect(self.status)
-        self.pushButton_3.clicked.connect(self.help)
-
-        self.radioButton.toggled.connect(self.lowGuinierAndPowerToggle)
-        self.radioButton_8.toggled.connect(self.hiFitAndFixToggle)
-
-        self.radioButton_3.toggled.connect(self.lowFitAndFixToggle)
-
-        # Bug workaround for QDataWidgetMapper() not reacting to checkbox clicks.
-        # https://bugreports.qt.io/browse/QTBUG-1818
-        self.checkBox.clicked.connect(self.setFocus)
-        self.checkBox_2.clicked.connect(self.setFocus)
+        """ """
+        self.cmdCalculate.clicked.connect(self.calculateInvariant)
+        self.cmdStatus.clicked.connect(self.onStatus)
+        self.cmdHelp.clicked.connect(self.onHelp)
+
+        self.chkLowQ.stateChanged.connect(self.stateChanged)
+        self.chkLowQ.stateChanged.connect(self.checkQExtrapolatedData)
+
+        self.chkHighQ.stateChanged.connect(self.stateChanged)
+        self.chkHighQ.stateChanged.connect(self.checkQExtrapolatedData)
+
+        # slots for the Guinier and PowerLaw radio buttons at low Q
+        # since they are not auto-exclusive
+        self.rbGuinier.toggled.connect(self.lowGuinierAndPowerToggle)
+
+        self.rbPowerLawLowQ.toggled.connect(self.lowGuinierAndPowerToggle)
+
+        self.rbFitHighQ.toggled.connect(self.hiFitAndFixToggle)
+
+        self.rbFitLowQ.toggled.connect(self.lowFitAndFixToggle)
 
         self.model.itemChanged.connect(self.modelChanged)
 
+        # update model from gui editing by users
+        self.txtBackgd.textChanged.connect(self.updateFromGui)
+
+        self.txtScale.textChanged.connect(self.updateFromGui)
+
+        self.txtContrast.textChanged.connect(self.updateFromGui)
+
+        self.txtPorodCst.textChanged.connect(self.updateFromGui)
+
+        self.txtPowerLowQ.textChanged.connect(self.updateFromGui)
+
+        self.txtPowerHighQ.textChanged.connect(self.updateFromGui)
+
+        self.txtNptsLowQ.textChanged.connect(self.updateFromGui)
+
+        self.txtNptsHighQ.textChanged.connect(self.updateFromGui)
+
+        # check values of n_points compared to distribution length
+        if self.txtNptsLowQ.isEnabled():
+            self.txtNptsLowQ.textChanged.connect(self.checkLength)
+
+        if self.txtNptsHighQ.isEnabled():
+            self.txtNptsHighQ.textChanged.connect(self.checkLength)
+
+    def stateChanged(self):
+        """
+        Catch modifications from low- and high-Q extrapolation check boxes
+        """
+        sender = self.sender()
+
+        itemf = QtGui.QStandardItem(str(sender.isChecked()).lower())
+        if sender.text() == 'Enable Low-Q extrapolation':
+            self.model.setItem(WIDGETS.W_ENABLE_LOWQ, itemf)
+
+        if sender.text() == 'Enable High-Q extrapolation':
+            self.model.setItem(WIDGETS.W_ENABLE_HIGHQ, itemf)
+
+    def checkLength(self):
+        """
+        Validators of number of points for extrapolation.
+        Error if it is larger than the distribution length
+        """
+        if self._data:
+            if len(self._data.x) < int(self.sender().text()):
+                self.sender().setStyleSheet(QtCore.QString(BG_RED))
+                logging.warning('The number of points must be smaller than {}'.format(len(self._data.x)))
+                self.cmdCalculate.setEnabled(False)
+            else:
+                self.sender().setStyleSheet(QtCore.QString(BG_WHITE))
+                self.cmdCalculate.setEnabled(True)
+        else:
+            # logging.info('no data is loaded')
+            self.cmdCalculate.setEnabled(False)
+
     def modelChanged(self, item):
-        """
-        """
+        """ Update when model changed """
         if item.row() == WIDGETS.W_ENABLE_LOWQ:
             toggle = (str(item.text()) == 'true')
